#include "Div.h"
#include "LCD.h"


uint8_t RS232SPuffer[64], SPufferWr, SPufferRd, SendArt;



uint8_t ZeichenSendenPruefung(void) // zykl. Aufruf notwendig
{
 if (SPufferWr==SPufferRd) return 0; // keine Aktion notwendig
 if ( !( UCSR0A & (1<<UDRE0)) ) return 1; // warten bis UDR frei; UDRE0=1: UDR ist frei
 UDR0 = RS232SPuffer[SPufferRd];
 SPufferRd = (SPufferRd+1) & 63; // Zeiger mod 64 erhhen, berlaufprfung fehlt
 return 2;
} 


void SendZeichDirekt(uint8_t Zeich) // 
{
 while (!(UCSR0A & (1<<UDRE0))); //Warten solange bis Zeichen gesendet wurde
 UDR0 = Zeich;
}

void SendZeich(uint8_t Zeich) // 
{
 if (SendArt&0x80) LCD_Disp(Zeich); 
 if (SendArt&0x40) return;
 RS232SPuffer[SPufferWr] = Zeich; // Zeichen in Ringpuffer
 SPufferWr = (SPufferWr+1) & 63;  // Zeiger mod 64 erhhen, berlaufprfung fehlt
}


void SendString_P(const prog_char Txt[]) /* String aus Flash */
{
uint8_t Zeich;
 while ( (Zeich=pgm_read_byte(Txt++)) !=0 ) SendZeich(Zeich);
}


void SendString(uint8_t Txt[]) /* String aus RAM */
{
uint8_t Zeich;
 while ( (Zeich=*(Txt++)) !=0 ) SendZeich(Zeich);
}

void SendLF(void)
{
 SendZeich(0x0D); SendZeich(0x0A);
}

/*
 SendDezH(1034,0x12); // "10.34"    SendDezH(695,0x11); // "69.5"
 SendDezH(02,0x32); // "02 "        SendDezH(95,0x11); // "9.5 "
 SendDezH(12,0x33); // "12 "        SendDezH(795,0x12); // "7.95"
 SendDezH(14,0x30); // "14 "        SendDezH(15,0x05); // "0.00015"
*/
void SendDezH(int32_t Wert, uint8_t St) /* St: Kommastelle */
{ // hchste Int-Zahl: 7FFFFFFFh =2.147.483.647
uint8_t  i,j,Bl = 0, fNull = 0; 
int32_t DivMuster[10] = {1000000000,100000000,10000000,1000000,100000,10000,1000,100,10,1}; /* zur Umcodierung */
 if (Wert<0) {SendZeich('-'); Wert = -Wert;}
 if (St&0x10) Bl = 1; // Blank am Ende
 if (St&0x40) Bl = 2; // Blank am Ende

 if (St&0x20) fNull = 2; // feste Stellenanzahl, fhrende Nullen
 St &= 0x0F;
 if (St) 
 {
   St = 9 - St; // von hinten
   if (fNull==2) St++;
 }
 else St = 255;    // wenn St=0, dann keine Komma

 i = 0;
 while (i<10)
 { int32_t DivMust;
   j = 0;
   DivMust = DivMuster[i];
   while (Wert>=DivMust)
   {
    Wert = Wert - DivMust;
    j = j + 1;
    fNull |= 1; // erste Dez.-Stelle>0
   }
   if (i==St) fNull |= 1;
   if (fNull&1) SendZeich(j+48);  // in ASCII
   if (i==St && (fNull&2)==0) SendZeich('.');   // evtl. Komma einfgen
   i++;
  }
 if ((fNull&1)==0) SendZeich('0'); // nur wenn Wert=0
 if (Bl)    SendZeich(' ');
 if (Bl==2) SendZeich(' ');
}

void SendTemp(int16_t Temp)  // Temp um Faktor=10 erhht
{
 if (Temp<=-100)     SendDezH(Temp/10,0x70);
 else if (Temp<0)    SendDezH(Temp,0x11);
 else if (Temp<100)  SendDezH(Temp,0x51);
 else if (Temp<1000) SendDezH(Temp,0x11);
 else                SendDezH(Temp/10,0x70);
}




